searchNodes=[{"doc":"","ref":"Test1.html","title":"Test1","type":"module"},{"doc":"","ref":"Test1.html#performance/0","title":"Test1.performance/0","type":"function"},{"doc":"","ref":"Test1.html#run/0","title":"Test1.run/0","type":"function"},{"doc":"","ref":"Test1.html#wop/0","title":"Test1.wop/0","type":"function"},{"doc":"XPeg is a pure Elixir pattern matching library. It provides macros to compile patterns and grammars (PEGs) to Elixir function which will parse a string and collect selected parts of the input. PEGs are not unlike regular expressions, but offer more power and flexibility, and have less ambiguities. (More about PEGs on Wikipedia ) Some use cases where XPeg is useful are configuration or data file parsers, robust protocol implementations, input validation, lexing of programming languages or domain specific languages. Examples p = Xpeg . peg :dict do :dict &lt;- :pair * star ( &quot;,&quot; * :pair ) * ! 1 :pair &lt;- :word * &quot;=&quot; * :number * fn [ a , b | cs ] -&gt; [ { b , a } | cs ] end :word &lt;- cap ( + { &#39;a&#39; .. &#39;z&#39; } ) :number &lt;- cap ( + { &#39;0&#39; .. &#39;9&#39; } ) * fn [ v | cs ] -&gt; [ String . to_integer ( v ) | cs ] end end Xpeg . match ( p , &quot;grass=4,horse=1,star=2&quot; )","ref":"Xpeg.html","title":"Xpeg","type":"module"},{"doc":"Execute a grammar against a subject string. The result is a map with the following fields: captures : The captures made by the grammar result : either :ok or :error , depending on a successful match of the subject time : Time taken to match the subject (seconds) match_len : The total number of UTF-8 characters matched userdata : Returned userdata","ref":"Xpeg.html#match/3","title":"Xpeg.match/3","type":"function"},{"doc":"Define a grammar with one anonymous rule.","ref":"Xpeg.html#patt/1","title":"Xpeg.patt/1","type":"macro"},{"doc":"Define a PEG grammar which uses start as the initial rule","ref":"Xpeg.html#peg/2","title":"Xpeg.peg/2","type":"macro"},{"doc":"Define a PEG grammar which uses start as the initial rule, allowing for additional options: :trace - if true , a trace is dumped during parser execution :dump_ir - if true , the IR (intermediate representation) of the generated parser is dumped at compile time :dump_code - if true , the generated Elixir code for the parser is dumped at compile time :userdata - if true , elixir functions that are embedded in the grammar take an additional accumulator argument and should return a tuple {captures | acc} - the resulting accumulator value is available as the userdata field in the return value of the `match()1 function","ref":"Xpeg.html#peg/3","title":"Xpeg.peg/3","type":"macro"},{"doc":"","ref":"Xpeg.html#state/2","title":"Xpeg.state/2","type":"macro"},{"doc":"More documentation will be added, for now please refer to the documentation of NPeg , a Nim implementation of a similar PEG parser.","ref":"readme.html","title":"README","type":"extras"},{"doc":"XPeg is a pure Elixir pattern matching library. It provides macros to compile patterns and grammars (PEGs) to Elixir function which will parse a string and collect selected parts of the input. PEGs are not unlike regular expressions, but offer more power and flexibility, and have less ambiguities. (More about PEGs on Wikipedia ) Some use cases where XPeg is useful are configuration or data file parsers, robust protocol implementations, input validation, lexing of programming languages or domain specific languages.","ref":"readme.html#introduction","title":"README - Introduction","type":"extras"},{"doc":"def deps do [ { :xpeg , &quot;~&gt; 0.4.0&quot; } ] end","ref":"readme.html#installation","title":"README - Installation","type":"extras"},{"doc":"Here is a simple example showing the power of XPeg: The macro peg compiles a grammar definition into a parser functiion, which is used to match a string and place the key-value pairs into a list of tuples: p = Xpeg . peg :dict do :dict &lt;- :pair * star ( &quot;,&quot; * :pair ) * ! 1 :pair &lt;- :word * &quot;=&quot; * :number * fn [ a , b | cs ] -&gt; [ { b , a } | cs ] end :word &lt;- cap ( + { &#39;a&#39; .. &#39;z&#39; } ) :number &lt;- cap ( + { &#39;0&#39; .. &#39;9&#39; } ) * fn [ v | cs ] -&gt; [ String . to_integer ( v ) | cs ] end end Xpeg . match ( p , &quot;grass=4,horse=1,star=2&quot; ) Output: [ { &quot;star&quot; , 2 } , { &quot;horse&quot; , 1 } , { &quot;grass&quot; , 4 } ]","ref":"readme.html#quickstart","title":"README - Quickstart","type":"extras"},{"doc":"The basic operation consists of the provided grammar , which consists of a set of named rules . A rule is made up of a number of atoms (not to be confused with Elixirs atom) and operators , which are executed to match the input string. Rules can also call into other rules, allowing for recursive grammars. For example, the grammar below matches a comma-separated list of words p = peg :list do :list &lt;- :word * star ( &quot;,&quot; * :word ) :word &lt;- + { &#39;a&#39; .. &#39;z&#39; } end The :list rule matches one :word , followed by zero or more ( star(P) ) times a , followed by a :word The :word rule matches one-or-more ( +P ) times the set of characters ( {} ) consisting of all letters from 'a' to 'z' During the execution of the grammar, matching parts of the subject strings can be captured with the cap() operator. All captures are stored on the captures list inside the parser state. This list is returned by the match() function, but can also be used by in-grammar functions to perform conversions or transformations. Below is the same grammar as above, but in this case it captures all the individual :word: s: p = peg :list do :list &lt;- :word * star ( &quot;,&quot; * :word ) :word &lt;- cap ( + { &#39;a&#39; .. &#39;z&#39; } ) end match ( p , &quot;one,two,three&quot; ) The above will return these following list of captures: [ &quot;three&quot; , &quot;two&quot; , &quot;one&quot; ] A powerful feature allows mixing of Elixir functions with the grammar, which can be used to perform transformations of the captures or build abstract syntax trees (ASTs) on-the-fly. For example, the grammar above is changed to match numbers instead of words, and a conversion function is called after every matching number that converts the last captured value on the captures list to an integer: p = peg :list do :list &lt;- :word * star ( &quot;,&quot; * :word ) :word &lt;- cap ( + { &#39;0&#39; .. &#39;9&#39; } ) * fn [ v | cs ] -&gt; [ String . to_integer ( v ) | cs ] end end match ( p , &quot;123,42,31415&quot; ) which results in the following captures: [ 31415 , 42 , 123 ] More elaborate examples can be found in examples_test.exs , including a parser for arithmatic expressions and a full JSON parser.","ref":"readme.html#usage","title":"README - Usage","type":"extras"},{"doc":"The XPeg syntax is similar to normal PEG notation, but some changes were made to allow the grammar to be properly parsed by the Elixir compiler: XPeg uses prefix operators instead of suffix operators for + , - Elixir does not support the * and ? prefix operators, so instead star(P) and opt(P) are used The explicit * infix operator is used for concatenation XPeg patterns and grammars can be composed of the following parts: Atoms : 0 # matches always and consumes nothing 1 # matches any character n # matches exactly n characters &#39;x&#39; # matches literal character &#39;x&#39; &quot;xyz&quot; # matches literal string &quot;xyz&quot; { &#39;x&#39; .. &#39;y&#39; } # matches any character in the range from &#39;x&#39;..&#39;y&#39; { &#39;x&#39; , &#39;y&#39; , &#39;z&#39; } # matches any character from the set Operators : P1 * P2 # concatenation P1 | P2 # ordered choice P1 - P2 # matches P1 if P2 does not match ( P ) # grouping ! P # matches everything but P &amp; P # matches P without consuming input opt ( P ) # matches P zero or one times star ( P ) # matches P zero or more times + P # matches P one or more times P [ n ] # matches P n times P [ m .. n ] # matches P m to n times Captures : str ( P ) # Adds the matched string to the capture list int ( P ) # Adds the matched integer to the capture list float ( P ) # Adds the matched float to the capture list Elixir function : fn ( captures ) # Elixir function for transormations","ref":"readme.html#syntax","title":"README - Syntax","type":"extras"},{"doc":"XPeg is already useful, but still young and immature. Here's a list of things I want to fix: I do not like the star() and opt() syntax of the AST, but given the limited support for prefix operators in Elixir I'm not yet sure how to make this better","ref":"readme.html#todo","title":"README - TODO","type":"extras"}]